/* class IMKB
 * Authors: Umut Benzer, zlem Grses, Hseyin Yaar, Didem Kayal
 * 
 */

public class IMKB {
	/* function main 
	 * Author: Umut Benzer
	 */
	public static void main(String[] args) {

		System.out.println("kmez Biliim Sistemleri Gururla Sunar :)\n"
				+ "Veri Yaplar Proje 1.2\n" + "IMKB Endeks 0.2\n\n"
				+ "05-06-7657  Hseyin YAAR\n" + "05-06-7669  Didem KAYALI\n"
				+ "05-06-7670  Umut BENZER\n" + "05-07-8496  zlem GRSES\n\n");

		int ay = 1;
		float toplamIMKBDeger = 0;
		int toplamIMKBSayi = 0;
		float gecenAyIMKBDeger = deger(0);

		int oncekiIMKBSeans = 0;

		/* En yksek  deerin ve seans numaralarnn tutulaca yap. */
		float IMKBEnYuksekDeger[] = { -1, -1, -1 };
		int IMKBEnYuksekSeans[] = { -1, -1, -1 };

		/* En dk  deerin ve seans numaralarnn tutulaca yap. */
		float IMKBEnDusukDeger[] = { -1, -1, -1 };
		int IMKBEnDusukSeans[] = { -1, -1, -1 };

		for (int sayac = 1; sayac <= 730; sayac++) {
			/*
			 * Bu yln her seans iin ilem tekrarlanr.
			 */

			if (deger(sayac) != -1) { /* Eer tatil gnne denk gelmediysek */

				/* Her seans iin deiim fark bulunup ekrana yazdrlr */
				System.out
						.println(((oncekiIMKBSeans == 0) ? "Bir nceki yln son gn "
								: hangiAy(oncekiIMKBSeans) + ". ayn "
										+ hangiGun(oncekiIMKBSeans) + ". gn ")
								+ ((sayac % 2 == 0) ? "1" : "2")
								+ ". seans ile "
								+ hangiAy(sayac)
								+ ".ayn "
								+ hangiGun(sayac)
								+ ". gn "
								+ ((sayac % 2 == 0) ? "2" : "1")
								+ ". seans aras deiim oran: "
								+ degisimOrani(deger(oncekiIMKBSeans), deger(sayac))
								+ "%");

				/*
				 * Deiim oranlarn hesaplarken tatil gnlerinde hata olmamas
				 * iin bir nceki seansn deeri bu deikende tutulur.
				 */
				oncekiIMKBSeans = sayac;

				/*
				 * O ayn seans verileri toplamIMKBDeger deikenine eklenir.
				 * Ayda ka seans olduu toplamIMKBSayi ile hatrlanr.,
				 */
				toplamIMKBDeger += deger(sayac);
				toplamIMKBSayi++;

				/*
				 * En dk deer olup olmadn aratr. IMKBEnDusuk[2] kk
				 * deerlerin en byn, IMKBEnDusuk[0] kk deerlerin en
				 * kn saklar.
				 */
				if ((deger(sayac) <= IMKBEnDusukDeger[2])
						|| IMKBEnDusukDeger[2] == -1) {
					if ((deger(sayac) <= IMKBEnDusukDeger[1])
							|| IMKBEnDusukDeger[1] == -1) {
						if ((deger(sayac) <= IMKBEnDusukDeger[0])
								|| IMKBEnDusukDeger[0] == -1) {
							/* imdiye kadarki en kk deeri bulduk! */
							IMKBEnDusukDeger[2] = IMKBEnDusukDeger[1];
							IMKBEnDusukSeans[2] = IMKBEnDusukSeans[1];

							IMKBEnDusukDeger[1] = IMKBEnDusukDeger[0];
							IMKBEnDusukSeans[1] = IMKBEnDusukSeans[0];

							IMKBEnDusukDeger[0] = deger(sayac);
							IMKBEnDusukSeans[0] = sayac;
						} else {
							/* imdiye kadarki en kk ikinci deeri bulduk! */
							IMKBEnDusukDeger[2] = IMKBEnDusukDeger[1];
							IMKBEnDusukSeans[2] = IMKBEnDusukSeans[1];

							IMKBEnDusukDeger[1] = deger(sayac);
							IMKBEnDusukSeans[1] = sayac;
						}
					} else {
						/* imdiye kadarki en kk nc deeri bulduk! */
						IMKBEnDusukDeger[2] = deger(sayac);
						IMKBEnDusukSeans[2] = sayac;
					}
				}

				/*
				 * En yksek deer olup olmadn aratr. IMKBEnYuksek[2]
				 * byk deerlerin en kn, IMKBEnYuksek[0] byk
				 * deerlerin en byn saklar.
				 */
				if ((deger(sayac) >= IMKBEnYuksekDeger[2])
						|| IMKBEnYuksekDeger[2] == -1) {
					if ((deger(sayac) >= IMKBEnYuksekDeger[1])
							|| IMKBEnYuksekDeger[1] == -1) {
						if ((deger(sayac) >= IMKBEnYuksekDeger[0])
								|| IMKBEnYuksekDeger[0] == -1) {
							/* imdiye kadarki en byk deeri bulduk! */
							IMKBEnYuksekDeger[2] = IMKBEnYuksekDeger[1];
							IMKBEnYuksekSeans[2] = IMKBEnYuksekSeans[1];

							IMKBEnYuksekDeger[1] = IMKBEnYuksekDeger[0];
							IMKBEnYuksekSeans[1] = IMKBEnYuksekSeans[0];

							IMKBEnYuksekDeger[0] = deger(sayac);
							IMKBEnYuksekSeans[0] = sayac;
						} else {
							/* imdiye kadarki en kk ikinci deeri bulduk! */
							IMKBEnYuksekDeger[2] = IMKBEnYuksekDeger[1];
							IMKBEnYuksekSeans[2] = IMKBEnYuksekSeans[1];

							IMKBEnYuksekDeger[1] = deger(sayac);
							IMKBEnYuksekSeans[1] = sayac;
						}
					} else {
						/* imdiye kadarki en kk nc deeri bulduk! */
						IMKBEnYuksekDeger[2] = deger(sayac);
						IMKBEnYuksekSeans[2] = sayac;
					}
				}

				/* Ayn son seansna gelmisek */
				if (hangiAy(sayac + 1) != ay) {
					System.out.println("\n" + ay
							+ ".ay iin endeks ortalamas: "
							+ (toplamIMKBDeger / toplamIMKBSayi));
					System.out.println(((ay == 1) ? "Geen yln son ay"
							: (ay - 1) + ". ay")
							+ " ile "
							+ ay
							+ ". ay arasndaki deiim oran: "
							+ degisimOrani(gecenAyIMKBDeger, deger(sayac))
							+ "%\n");
					gecenAyIMKBDeger = deger(sayac);
					toplamIMKBDeger = 0;
					toplamIMKBSayi = 0;
					ay++;
				}
			}
		}

		System.out.println("\n\nEndeksin en dk olduu  gn:");

		for (int sayac = 0; sayac < 3; sayac++) {
			System.out.println(hangiAy(IMKBEnDusukSeans[sayac]) + ". ayn "
					+ hangiGun(IMKBEnDusukSeans[sayac]) + ". gnnn "
					+ ((IMKBEnDusukSeans[sayac] % 2 == 0) ? "2" : "1")
					+ ". seans. (Puan: " + IMKBEnDusukDeger[sayac] + ")");
		}

		System.out.println("\n\nEndeksin en yksek olduu  gn:");

		for (int sayac = 0; sayac < 3; sayac++) {
			System.out.println(hangiAy(IMKBEnYuksekSeans[sayac]) + ". ayn "
					+ hangiGun(IMKBEnYuksekSeans[sayac]) + ". gnnn "
					+ ((IMKBEnYuksekSeans[sayac] % 2 == 0) ? "2" : "1")
					+ ". seans. (Puan: " + IMKBEnYuksekDeger[sayac] + ")");
		}

	}

	/* function hangiGun 
	 * Author: Didem Kayal
	 * 
	 * @param: Seans numaras
	 * @return: Ayn bir gn (1-31) Seansn ayn hangi
	 * gnne ait olduunu dndrr.
	 */
	private static int hangiGun(int seansno) {
		int kalan = seansno % 2;

		if ((seansno >= 1) && (seansno <= 62)) {
			if (kalan == 1)
				return ((seansno / 2) + 1);
			else
				return (seansno / 2);
		} else if ((seansno >= 63) && (seansno <= 118)) {
			if (kalan == 1)
				return (((seansno - 62) / 2) + 1);
			else
				return ((seansno - 62) / 2);

		} else if ((seansno >= 119) && (seansno <= 180)) {
			if (kalan == 1)
				return (((seansno - 118) / 2) + 1);
			else
				return ((seansno - 118) / 2);
		} else if ((seansno >= 181) && (seansno <= 240)) {
			if (kalan == 1)
				return (((seansno - 180) / 2) + 1);
			else
				return ((seansno - 180) / 2);
		} else if ((seansno >= 241) && (seansno <= 302)) {
			if (kalan == 1)
				return (((seansno - 240) / 2) + 1);
			else
				return ((seansno - 240) / 2);
		} else if ((seansno >= 303) && (seansno <= 362)) {
			if (kalan == 1)
				return (((seansno - 302) / 2) + 1);
			else
				return ((seansno - 302) / 2);
		} else if ((seansno >= 363) && (seansno <= 424)) {
			if (kalan == 1)
				return (((seansno - 362) / 2) + 1);
			else
				return ((seansno - 362) / 2);
		} else if ((seansno >= 425) && (seansno <= 486)) {
			if (kalan == 1)
				return (((seansno - 424) / 2) + 1);
			else
				return ((seansno - 424) / 2);
		} else if ((seansno >= 487) && (seansno <= 546)) {
			if (kalan == 1)
				return (((seansno - 486) / 2) + 1);
			else
				return ((seansno - 486) / 2);
		} else if ((seansno >= 547) && (seansno <= 608)) {
			if (kalan == 1)
				return (((seansno - 546) / 2) + 1);
			else
				return ((seansno - 546) / 2);
		} else if ((seansno >= 609) && (seansno <= 668)) {
			if (kalan == 1)
				return (((seansno - 608) / 2) + 1);
			else
				return ((seansno - 608) / 2);
		} else if ((seansno >= 669) && (seansno <= 730)) {
			if (kalan == 1)
				return (((seansno - 668) / 2) + 1);
			else
				return ((seansno - 668) / 2);
		} else
			return -1;
	}

	/* function hangiAy
	 * Author: Didem Kayal
	 * 
	 * @param: Seans numaras
	 * @return: Yln bir ay (1-12) Seansn ayn hangi
	 * aya ait olduunu dndrr.
	 */
	private static int hangiAy(int seansno) {
		/* Didem */
		/* Eer 730'dan fazlaysa -1 dndrmeli */
		if ((seansno >= 1) && (seansno <= 62))
			return 1;

		else if ((seansno >= 63) && (seansno <= 118))

			return 2;

		else if ((seansno >= 119) && (seansno <= 180))

			return 3;

		else if ((seansno >= 181) && (seansno <= 240))

			return 4;

		else if ((seansno >= 241) && (seansno <= 302))

			return 5;

		else if ((seansno >= 303) && (seansno <= 362))

			return 6;

		else if ((seansno >= 363) && (seansno <= 424))

			return 7;

		else if ((seansno >= 425) && (seansno <= 486))

			return 8;

		else if ((seansno >= 487) && (seansno <= 546))

			return 9;

		else if ((seansno >= 547) && (seansno <= 608))

			return 10;

		else if ((seansno >= 609) && (seansno <= 668))

			return 11;

		else if ((seansno >= 669) && (seansno <= 730))

			return 12;

		else

			return -1;
	}

	/* function degisimOrani
	 * Author: Didem Kayal
	 * 
	 * @param: lk seansn deeri
	 * @param: kinci seansn deeri
	 * @return: Seanslar aras deiim oran 
	 * 
	 * Seanslar arasndaki deiim orann %
	 * cinsinden dndrr.
	 */
	private static float degisimOrani(float ilkyuzde, float sonyuzde) {
		return (100 * (sonyuzde - ilkyuzde)) / ilkyuzde;
	}

	/* function tatilMi 
	 * Author: zlem Grses
	 * 
	 * @param: Seans numaras
	 * @return: Seansn olmas gerektii gnn tatil olup
	 * olmad
	 */
	private static boolean tatilMi(int no) {
		int yil[] = { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
		int ay = hangiAy(no);
		int gun = 0;
		for (int i = 0; i < ay; i++) {
			gun += yil[i];
		}
		gun += hangiGun(no);

		/*
		 * JOptionPane.showMessageDialog(null, "Gn: " + gun + "\n" + "No" + no +
		 * "\nAy =" + ay + "\nhangigun(no) " + hangiGun(no),
		 * "tatilMi",JOptionPane.PLAIN_MESSAGE);
		 */

		if (gun % 7 == 0 || gun % 7 == 6)
			return true;
		else
			return false;

	}

	/* function deger
	 * Author: Hseyin Yaar
	 * 
	 * @param: Seans numaras
	 * @return: Eer seans tatil gnne denk gelmiyorsa
	 * rastgele bir seans deeri retir. Tatil gnleri iin -1 dndrr.
	 */
	private static float deger(int seansno) {
		if (tatilMi(seansno))
			return -1;

		float IMKBdegeri;
		IMKBdegeri = 30000 + 20000 * randomFonksiyon(seansno);
		return IMKBdegeri;
	}

	private static float randomFonksiyon(int x) {
		float y;
		y = (float) Math.sin(x) + (float) Math.sin(x / 2) + 2
				+ parcaliFonksiyon(x);
		// Math.sin(double x) metodu double dndrd iin her kullanmndan
		// nce floata evrilir.
		y /= 4;
		return y;
	}

	private static float parcaliFonksiyon(int a) {
		float x, y;
		x = a;
		if (0 <= x && x < 70)
			y = 0;
		else if (70 <= x && x < 315)
			y = -x / 180 + 1;
		else if (315 <= x && x < 450)
			y = 1;
		else if (450 <= x && x < 720)
			y = x / 360 + 2;
		else if (720 <= x)
			y = 0;
		else {
			System.out.println("Random hatas");
			return -1;
		}
		return y;
	}
}
